=== debian/changelog ===
openarena (0.8.5-7) unstable; urgency=low

  * Use ~/.openarena, not ~/openarena (Closes: #612782)

 -- Simon McVittie <smcv@debian.org>  Thu, 10 Feb 2011 17:30:00 +0000

openarena (0.8.5-6) unstable; urgency=low

  * Use com_basegame, com_homepath etc. from recent upstream ioquake3
    - depend on a suitably new snapshot
    - keep the older build-dependency, since all we actually need is q3arch.sh
  * Add an openarena-dbg package with debug symbols
  * Don't strcpy a buffer into itself, squashing a valgrind warning
  * Declare CG_FairCvars properly, squashing a compiler warning
  * Convert debian/copyright to machine-readable format

 -- Simon McVittie <smcv@debian.org>  Sat, 05 Feb 2011 22:30:39 +0000

openarena (0.8.5-5+exp3) experimental; urgency=low

  * Make the OPENARENA_BACKTRACE option work correctly

 -- Simon McVittie <smcv@debian.org>  Sun, 16 Jan 2011 22:27:02 +0000

openarena (0.8.5-5+exp2) experimental; urgency=low

  * Create a Debian-openarena user and install an init script (off by default)
    (Closes: #503106)
  * Add a README.Debian explaining alternative ways to run the server
  * Depend on an ioquake3-server new enough to install q3arch, and run that
    instead of having our own copy
  * Depend on debhelper 8 and convert the rules file to dh style

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Nov 2010 23:12:26 +0000

openarena (0.8.5-5+exp1) experimental; urgency=low

  * Install wrapper scripts for ioquake3, instead of our own engine
    - therefore we no longer use a local copy of libjpeg (Closes: #495966)
    - remove all patches that only change the engine
    - adjust FreeBSD portability patch to only apply to the game code
  * Set up debian/rules so DEB_BUILD_OPTIONS="noopt" does a debug build
  * Improve the man pages
  * Update q3arch.sh from ioquake3
    - don't warn when building on arm/armel
    - output the chosen architecture for the benefit of buildd logs

 -- Simon McVittie <smcv@debian.org>  Fri, 15 Oct 2010 21:17:55 +0100

openarena (0.8.5-5) unstable; urgency=medium

  * Add patch (already upstream as oax r239) to fix a crash if a non-client
    object is damaged by a non-player source, e.g. setting off the Kamikaze
    near a powerup (Closes: #599866)

 -- Simon McVittie <smcv@debian.org>  Mon, 11 Oct 2010 19:40:30 +0100

openarena (0.8.5-4) unstable; urgency=low

  * Build a second copy of the game logic and install it in a subdirectory.
    It turns out that OpenArena 0.8.1 and 0.8.5 aren't network-compatible.
  * Depend on openarena-data (>= 0.8.5-3~) which causes us to load the
    0.8.1-compatible game logic whenever the upstream version would use
    0.8.1's bytecode (Closes: #592965)

 -- Simon McVittie <smcv@debian.org>  Tue, 24 Aug 2010 20:20:07 +0100

openarena (0.8.5-3) unstable; urgency=medium

  * Add patch from oax r203 to fix server crashes if a player joins, then
    rapidly leaves or dies (Closes: #592020)

 -- Simon McVittie <smcv@debian.org>  Sun, 08 Aug 2010 11:53:58 +0100

openarena (0.8.5-2) unstable; urgency=low

  [ Simon McVittie ]
  * Improve patch tagging/attribution
  * Add patch from ioquake3 r1788 to avoid buffer overflows
  * Upload to unstable, now that -data 0.8.1+dfsg1-1 has migrated    

  [ Ansgar Burchardt ]
  * debian/control: Remove myself from Uploaders.

 -- Simon McVittie <smcv@debian.org>  Tue, 03 Aug 2010 10:58:54 +0100

openarena (0.8.5-1) experimental; urgency=low

  * New upstream version (Closes: #573995)
  * Repack upstream tarball to have engine and game subdirectories; the
    engine subdirectory is from ioquake3 svn, and the game subdirectory
    is from Open Arena Expanded (the stuff previously applied as a patch)
  * Apply some of the OpenArena changes to ioquake3 as Debian patches; move
    the remaining OpenArena changes to debian/unapplied/
  * Adjust previous Debian patches to apply to this structure
  * q3arch.sh: be more pedantic about the listed architectures, since they
    have to be kept in sync with q_platform.h (possibly fixing OA on mipsel,
    if it will even run there)
  * Add a stub watch file explaining why we can't use uscan for OA
  * Standards-Version: 3.9.1 (no changes needed)
    - one known Policy violation: the embedded libjpeg is filed as #495966

 -- Simon McVittie <smcv@debian.org>  Thu, 29 Jul 2010 21:05:41 +0100

openarena (0.8.1-8) unstable; urgency=low

  * Add myself to Uploaders
  * Standards-Version: 3.9.0 (no changes needed)
  * Ship the source code for the game logic (normally in QVN bytecode files,
    which need a non-free compiler), from openarena-modSDK-0.8.1.tar.bz2;
    compile it to native code and package it in openarena-server
    (Closes: #559240)
  * Make openarena depend on openarena-server, to avoid having to add a third
    binary package for the game code (this adds less than 1MB to an
    installation of openarena)
  * Load data from /usr/lib, and create symlinks to the PK3 files in
    /usr/share, to avoid having to define yet another search path
  * Load game logic as native code if the QVM file starts with magic number
    'NTVE', even on pure servers
  * Tighten versioned dependency on openarena-data - now that we're shipping
    the game logic here and the rest in openarena-data, we need to make sure
    they're in sync

 -- Simon McVittie <smcv@debian.org>  Thu, 22 Jul 2010 00:38:00 +0100

openarena (0.8.1-7) unstable; urgency=low

  * Use memmove instead of strcpy for overlapping memory regions.
    (LP: #554748)
    + new patch: memmove.patch
  * Fix spelling error.
    + new patch: spelling.patch
  * debian/control: Add ${misc:Depends} to binary package dependencies.
  * Bump Standards-Version to 3.8.4 (no changes).

 -- Ansgar Burchardt <ansgar@43-1.org>  Mon, 07 Jun 2010 13:49:36 +0900
