=== debian/control ===
Source: openarena
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Bruno "Fuddl" Kleinert <fuddl@debian.org>,
           Gonéri Le Bouder <goneri@rulezlan.org>,
           Simon McVittie <smcv@debian.org>
Build-Depends: debhelper (>= 8),
               imagemagick,
               ioquake3-server (>= 1.36+svn1802-1~),
               libcurl4-gnutls-dev,
               libjpeg62-dev,
               libopenal-dev,
               libsdl1.2-dev,
               libspeexdsp-dev,
               libvorbis-dev
Standards-Version: 3.9.1
Vcs-Git: git://git.debian.org/git/pkg-games/openarena.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/openarena.git;a=summary
Homepage: http://openarena.ws/

Package: openarena
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
         ioquake3 (>= 1.36+svn1858),
         openarena-data (>= 0.8.5-3~), openarena-data (<< 0.8.6~),
         openarena-server (= ${binary:Version})
Description: fast-paced 3D first-person shooter
 OpenArena is an open-source content package for ioQuake3 licensed under the
 GPL, effectively creating a free stand-alone game. Though OpenArena is a free
 replacement for id Software Inc.'s Quake 3 Arena, it is NOT compatible with
 the proprietary game!
 .
 OpenArena might be considered unsuitable for children.
 .
 This package installs the OpenArena client.

Package: openarena-server
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
         adduser,
         ioquake3-server (>= 1.36+svn1858),
         openarena-data (>= 0.8.5), openarena-data (<< 0.8.6~)
Description: server and game logic for the game OpenArena
 OpenArena is an open-source content package for ioQuake3 licensed under the
 GPL, effectively creating a free stand-alone game. Though OpenArena is a free
 replacement for id Software Inc.'s Quake 3 Arena, it is NOT compatible with
 the proprietary game!
 .
 This package installs the OpenArena dedicated server, and the game logic files
 needed by both the client and the server.

Package: openarena-dbg
Section: debug
Priority: extra
Architecture: any
Depends: openarena-server (= ${binary:Version}), ${misc:Depends}
Recommends: ioquake3-dbg
Description: debug symbols for OpenArena's game logic
 OpenArena 
 .
 OpenArena is an open-source content package for ioQuake3 licensed under the
 GPL, effectively creating a free stand-alone game. Though OpenArena is a free
 replacement for id Software Inc.'s Quake 3 Arena, it is NOT compatible with
 the proprietary game!
